//Snake
//By BeefMan

#include <stdlib.h>
#include <math.h>
#include <stdio.h>
#include <nuon/time.h>
#include <nuon/mml2d.h>
#include <nuon/joystick.h>
#include <nuon/synth.h>
#include <nuon/termemu.h>
#include <nuon/bios.h>
#include <nuon/dma.h>
#include <nuon/video.h>
#include <nuon/sprite.h>

/**************************************************************************/
/**************************************************************************/
/**************************************************************************/
extern char StartScreen[];
extern char NuonLogo[];
extern uint8 CollegeScript_TTF[];
extern char FruitEatWav[];
extern char ahhWav[];
extern char MenuWav[];
extern char GoWav[];
extern char PauseWav[];
extern char SnakeHissWav[];
extern int PlayWAV(void *wavaddr, int voice, PCMPOS *Pan, int volume, int echo );
extern short MidiFile[];

static AUDIO_RESOURCES audiorsc = { 1, 0, 0, 0 };	
/**************************************************************************/
/**************************************************************************/
/**************************************************************************/

#define IRKey1(a) (a.remote_buttons & IR_KEY_1)
#define IRKey6(a) (a.remote_buttons & IR_KEY_6)
#define IRKey2(a) (a.remote_buttons & IR_KEY_2)
#define IRKey8(a) (a.remote_buttons & IR_KEY_8)
#define IRKey4(a) (a.remote_buttons & IR_KEY_4)

//framebuffers for sprite stuff :)
#define NUM_BUFFERS 3
//sprite stuff
#define DMAFLAGS  (DMA_PIXEL_WRITE | ((640/8)<<16) | (4<<4) | (1<<11))
VidDisplay display;
VidChannel mainchannel;
#define SCREEN_WIDTH 640
#define SCREEN_HEIGHT 480
//tga sprite stuff
	SPR_IMAGE_INFO spr_source, StartScr, NuonLgo;
	void *FrameBuffer[NUM_BUFFERS];
	char *localScratch;
	int localSize;


void PlotPixel( mmlGC* gcP, mmlDisplayPixmap* screenP, int x, int y, mmlColor color );

		mmlSysResources sysRes;
    	mmlGC gc;
		mmlAppPixmap source, clutSource;
    	mmlDisplayPixmap screen, screen2, screen3, screen4;
    	int srcWide, srcHigh;
    	uint16* srcP;
    	mmlColor black;

	typedef struct 
	{
		int x_pos;
		int	y_pos;
		int trail_x[500];
		int trail_y[500];
		int snakeHead;
		int snakeMax;
		int points;
		mmlColor snake_color;
	}sPlayer;

	sPlayer player[2];	
		
	//game variables
	int player_num=0;
	int flash=0;
	int hiscore=0;
	int hiscore_2p=0;
	int freeze_p1_timer=0;
	int freeze_p2_timer=0;
	int wait=0;
	int single_player=0;
	int two_player=0;
	int options=0;
	int credits=0;
	int menu_down=0;
	int menu_up=4;
	int main_menu=1;
	int win=0;

	//snake control
	int i=0;
	int a=0;
	int p;
	int speed=100;

	//loop control
	int interval;
	int quit=0;
	
	//pellets
	int pellet_x;
	int pellet_y;
	int pellet_x_2;
	int pellet_y_2;
	int pellet_freeze_x;
	int pellet_freeze_y;
	int pellet_present=0;
	int pellet_present_2=0;
	int pellet_freeze_present=0;

	//text
	mmlFontContext fc;
	mmlFont CollegeScriptP;
	mmlFont systemfont;
	m2dRect r2;//player 1 score box
	m2dRect r3;//player 2 score box
	m2dRect r4;//player win box
	m2dRect r5;
	m2dRect r6;
	m2dRect r7;
	m2dRect r8;
	m2dRect r9;
	char buffer[6];
	
	//playfield box
	m2dBox b1;

	//snake direction 
	int right=0;
	int left=0;
	int up=0;
	int down=0;

	//snake direction p2
	int right_p2=0;
	int left_p2=0;
	int up_p2=0;
	int down_p2=0;

	//audio
	PCMPOS Pan;

void snake(int player_index);
void pellet();
void score(int player_index);

/*
    Simple routine to draw a filled rectangle (via DMA)
*/
void myFillRect(char *screen, int dmaflags, int initx, int inity, int wide, int high, int color)
{
  int x, y;
  int lastx, lasty;
 
  lastx = initx + wide;
  lasty = inity + high;
  
  for (x = initx; x < lastx; x += 8)
    for (y = inity; y < lasty; y += 8)
      _raw_plotpixel(dmaflags, (void *) screen, (8<<16) | x, (8<<16) | y, color);
}

#define PIXEL_TYPE e888Alpha

int main( )
{
	
	AUDIOInitX(&audiorsc);//setup music
	
	/* Setup wav audio */
	AUDIOInit();

    Pan.PCMPanLR = 0;
    Pan.PCMPanFB = 0;
    Pan.PCMPanUD = 0;
	
	//setup players
	player[0].snakeHead=-1;
	player[0].snakeMax=30;

	player[1].snakeHead=-1;
	player[1].snakeMax=30;

	player[0].snake_color=kRed;
	player[1].snake_color=kYellow;

	player[0].points=0;
	player[1].points=0;

	
	//display TGA image taken from chomp
//********************************************************************************
	
    // Setup video 
	for(i=0;i<NUM_BUFFERS;i++)
	    FrameBuffer[i]=_MemAlloc(640*480*4,512,kMemSDRAM);
	
 	myFillRect(FrameBuffer[0], DMAFLAGS, 0, 0, 640, 480, kBlack);
	myFillRect(FrameBuffer[1], DMAFLAGS, 0, 0, 640, 480, kBlack);
	
	display.dispwidth = -1;
	display.dispheight = -1;
	display.bordcolor=0x20100000;
	display.progressive=0;
	for(i=0;i<6;i++)
		display.reserved[i]=0;
	
	mainchannel.dmaflags=DMAFLAGS;
	mainchannel.base=FrameBuffer[0];
	mainchannel.dest_xoff = -1;
	mainchannel.dest_yoff = -1;
	mainchannel.dest_width = 720;
	mainchannel.dest_height = 480;
	mainchannel.src_xoff = 0;
	mainchannel.src_yoff = 0;
	mainchannel.src_width = 640;
	mainchannel.src_height = 480;
	mainchannel.clut_select=0;
	mainchannel.alpha=0;
	mainchannel.vfilter=VID_VFILTER_2TAP;
	mainchannel.hfilter=VID_HFILTER_4TAP;
	for(i=0;i<5;i++)
		mainchannel.reserved[i]=0;
   
    InitTerminalX(0,(int)FrameBuffer[0],SCREEN_WIDTH, SCREEN_HEIGHT, DMAFLAGS, kBlack);                                                              
    _VidConfig ( &display, &mainchannel, 0, 0L); 

	srand(_VidSync(-1));
	
	// Use only MPE 2 for rendering, 16 pixel slices, prevent conflicts with other libs
    SPRInit(2,2,16);

    // Set to the second framebuffer
	SPRSetDestScreen(FrameBuffer[1], DMAFLAGS,  0,  0,  639,  479, kBlack);

    // Install the TGA images
    SPRInstallTGAImage(StartScreen, 1, &StartScr, 0x00);
    SPRInstallTGAImage(NuonLogo, 1, &NuonLgo, 0x00);
	
	//NUON Logo
	SPRBlitter(NuonLgo.img, NuonLgo.dmaflags, 0, 0, 640, 480,
            	FrameBuffer[1], DMAFLAGS, 640/2, 480/2,
            	0x0C000, 0x0C000, 0, 0, 0,639,479,
            	0x40000002, 0);
	
	_VidChangeBase(VID_CHANNEL_MAIN, mainchannel.dmaflags, FrameBuffer[1]);

	SPRWait();

	_VidSync(0);

	PlayWAV((void *)SnakeHissWav, -1, &Pan, 0x40000000, 0x40000000 );

	_TimeToSleep(2500);//control speed of snake or program
	_TimeToSleep(2500);//control speed of snake or program
	
	SYNTHStartMidiParser((long)MidiFile);//play midi song
	SYNTHNextMidiFile((long)MidiFile);

	// Title screen
	SPRBlitter(StartScr.img, StartScr.dmaflags, 0, 0, 640, 480,
            	FrameBuffer[1], DMAFLAGS, 640/2, 480/2,
            	0x0F333, 0x0F333, 0, 0, 0,639,479,
            	0x40000002, 0);
	
	_VidChangeBase(VID_CHANNEL_MAIN, mainchannel.dmaflags, FrameBuffer[1]);

	SPRWait();

	_VidSync(0);
	
	_TimeToSleep(2000);//control speed of snake or program

// ********************************************************************************
	
	do
	{	
		if(ButtonStart(_Controller[1]))
		{
			wait=1;
		}
	}while(wait==0);
	
	wait=0;

	/* Initialize the system resources and graphics context to a default state. */
	mmlPowerUpGraphics( &sysRes );
	mmlInitGC( &gc, &sysRes );

	/* Initialize a single display pixmap as a framebuffer
    120 pixels wide by 120 lines tall, using 32 bit YCC-alpha pixels. */
    mmlInitDisplayPixmaps( &screen, &sysRes, 120, 120, PIXEL_TYPE, 1, NULL );
	mmlInitDisplayPixmaps( &screen2, &sysRes, 240, 240, PIXEL_TYPE, 1, NULL );
	mmlInitDisplayPixmaps( &screen3, &sysRes, 120, 120, PIXEL_TYPE, 1, NULL );
	mmlInitDisplayPixmaps( &screen4, &sysRes, 480, 480, PIXEL_TYPE, 1, NULL );

	/* Allocate memory for a 16-bit rgb source pixmap and initialize
	the pixmap. */
	srcWide = 120;
	srcHigh = 120;
	srcP = (uint16*)malloc( 2 * srcWide * srcHigh );
	mmlInitAppPixmaps( &source, &sysRes, srcWide, srcHigh, eRGBAlpha1555, 1, srcP);
		
	black = mmlColorFromRGB( 0, 0, 0 );

	// Set all the pixels in the display pixmap to black 
	m2dFillColr( &gc, &screen2, NULL, black );
	
	/* show the sample pixmap */
	mmlSimpleVideoSetup(&screen2, &sysRes, eNoVideoFilter);
	
	/* Setup fonts */
	mmlInitFontContext( &gc, &sysRes, &fc, 4096 );
	CollegeScriptP = mmlAddFont( fc, "CollegeScript", eTrueType, CollegeScript_TTF, 69224 );
	
	//Menus
	m2dSetRect( &r5, 60, 90, 215, 140 );
	m2dSetRect( &r6, 60, 110, 215, 160 );
	m2dSetRect( &r7, 60, 130, 215, 180 );
	m2dSetRect( &r8, 60, 150, 215, 200 );
	mmlSetTextProperties( fc, CollegeScriptP, 10, kGreen, black, eOpaque, 0, 0 );
	mmlSimpleDrawText( fc, &screen2, "Single Player", 13, &r5);
	mmlSetTextProperties( fc, CollegeScriptP, 10, kBlue, black, eOpaque, 0, 0 );
	mmlSimpleDrawText( fc, &screen2, "Two Player", 10, &r6);
	mmlSimpleDrawText( fc, &screen2, "Options", 7, &r7);
	mmlSimpleDrawText( fc, &screen2, "Credits", 7, &r8);

	//if(IRKey1(_Controller[0]))
		
	a=0;
	
	while(quit<1)
	{
		
		/* show the sample pixmap */
		mmlSimpleVideoSetup(&screen2, &sysRes, eNoVideoFilter);
		
		while(main_menu==1)	
		{	
			
			m2dSetRect( &r5, 50, 40, 215, 140 );
			mmlSetTextProperties( fc, CollegeScriptP, 18, kGreen, black, eOpaque, 0, 0 );
			mmlSimpleDrawText( fc, &screen2, "Main Menu", 9, &r5);
			
			_TimeToSleep(165);//control speed of snake or program

			if((ButtonDown(_Controller[1]))&&(menu_down<3))
			{
				
				PlayWAV((void *)MenuWav, -1, &Pan, 0x40000000, 0x40000000 );

				menu_down++;
				
				if(menu_down==1)
				{
					m2dSetRect( &r5, 60, 90, 215, 140 );
					mmlSetTextProperties( fc, CollegeScriptP, 10, kBlue, black, eOpaque, 0, 0 );
					mmlSimpleDrawText( fc, &screen2, "Single Player", 13, &r5);
					
					m2dSetRect( &r6, 60, 110, 215, 160 );
					mmlSetTextProperties( fc, CollegeScriptP, 10, kGreen, black, eOpaque, 0, 0 );
					mmlSimpleDrawText( fc, &screen2, "Two Player", 10, &r6);
				}
				
				if(menu_down==2)
				{
					m2dSetRect( &r6, 60, 110, 215, 160 );
					mmlSetTextProperties( fc, CollegeScriptP, 10, kBlue, black, eOpaque, 0, 0 );
					mmlSimpleDrawText( fc, &screen2, "Two Player", 10, &r6);
					
					m2dSetRect( &r7, 60, 130, 215, 180 );
					mmlSetTextProperties( fc, CollegeScriptP, 10, kGreen, black, eOpaque, 0, 0 );
					mmlSimpleDrawText( fc, &screen2, "Options", 7, &r7);
				}

				if(menu_down==3)
				{
					m2dSetRect( &r7, 60, 130, 215, 180 );
					mmlSetTextProperties( fc, CollegeScriptP, 10, kBlue, black, eOpaque, 0, 0 );
					mmlSimpleDrawText( fc, &screen2, "Options", 7, &r7);

					m2dSetRect( &r8, 60, 150, 215, 200 );
					mmlSetTextProperties( fc, CollegeScriptP, 10, kGreen, black, eOpaque, 0, 0 );
					mmlSimpleDrawText( fc, &screen2, "Credits", 7, &r8);
				}
				menu_up--;
			}
			if((ButtonUp(_Controller[1]))&&(menu_up<4))
			{
				
				PlayWAV((void *)MenuWav, -1, &Pan, 0x40000000, 0x40000000 );
				menu_down--;
				  
				if(menu_up==1)
				{
					m2dSetRect( &r8, 60, 150, 215, 200 );
					mmlSetTextProperties( fc, CollegeScriptP, 10, kBlue, black, eOpaque, 0, 0 );
					mmlSimpleDrawText( fc, &screen2, "Credits", 7, &r8);

					m2dSetRect( &r7, 60, 130, 215, 180 );
					mmlSetTextProperties( fc, CollegeScriptP, 10, kGreen, black, eOpaque, 0, 0 );
					mmlSimpleDrawText( fc, &screen2, "Options", 7, &r7);
				}

				if(menu_up==2)
				{
					m2dSetRect( &r7, 60, 130, 215, 180 );
					mmlSetTextProperties( fc, CollegeScriptP, 10, kBlue, black, eOpaque, 0, 0 );
					mmlSimpleDrawText( fc, &screen2, "Options", 7, &r7);

					m2dSetRect( &r6, 60, 110, 215, 160 );
					mmlSetTextProperties( fc, CollegeScriptP, 10, kGreen, black, eOpaque, 0, 0 );
					mmlSimpleDrawText( fc, &screen2, "Two Player", 10, &r6);
				}

				if(menu_up==3)
				{
					m2dSetRect( &r6, 60, 110, 215, 160 );
					mmlSetTextProperties( fc, CollegeScriptP, 10, kBlue, black, eOpaque, 0, 0 );
					mmlSimpleDrawText( fc, &screen2, "Two Player", 10, &r6);
					
					m2dSetRect( &r5, 60, 90, 215, 140 );
					mmlSetTextProperties( fc, CollegeScriptP, 10, kGreen, black, eOpaque, 0, 0 );
					mmlSimpleDrawText( fc, &screen2, "Single Player", 13, &r5);
				}
				menu_up++;
			}
				
			if((ButtonA(_Controller[1]))&&(menu_down==3)&&(menu_up==1))
			{
				
				PlayWAV((void *)FruitEatWav, -1, &Pan, 0x40000000, 0x40000000 );
				
				//Erase the screen
				m2dFillColr( &gc, &screen4, NULL, black );
				
				/* show the sample pixmap */
				mmlSimpleVideoSetup(&screen4, &sysRes, eNoVideoFilter);
				
				//int scroll_y=15;
				//int scroll_y_2=400;
				//a=0;

				//do{
				//Special Thanks
				m2dSetRect( &r5, 25, 25, 450, 55 );
				m2dSetRect( &r6, 25, 55, 450, 85 );
				m2dSetRect( &r7, 25, 85, 450, 115 );
				m2dSetRect( &r8, 25, 115, 450, 145 );
				m2dSetRect( &r9, 25, 145, 450, 175 );
				
				mmlSetTextProperties( fc, CollegeScriptP, 14, kGreen, black, eOpaque, 0, 0 );
				mmlSimpleDrawText( fc, &screen4, "Thanks to:", 10, &r5);
				mmlSimpleDrawText( fc, &screen4, "Skah_T - Major Coding Help", 26, &r6);
				mmlSimpleDrawText( fc, &screen4, "Kevin Manne - Graphics & Audio", 30, &r7);	
				mmlSimpleDrawText( fc, &screen4, "VMLabs & Mr.X - NUON & Public SDK", 33, &r8);
				mmlSimpleDrawText( fc, &screen4, "Riff & Stephen - Coding Help",28, &r9);
				
				m2dSetRect( &r5, 25, 185, 450, 215 );
				m2dSetRect( &r6, 25, 215, 450, 235 );
				m2dSetRect( &r7, 25, 245, 450, 265 );

				mmlSimpleDrawText( fc, &screen4, "Play testing", 12, &r5);
				mmlSimpleDrawText( fc, &screen4, "Audrey, HolyWater, Justin, Kevin,", 33, &r6);
				mmlSimpleDrawText( fc, &screen4, "& Kati", 6, &r7);

				m2dSetRect( &r5, 25, 285, 450, 305 );
				m2dSetRect( &r6, 25, 315, 450, 345 );
				mmlSimpleDrawText( fc, &screen4, "Special Thanks to:", 18, &r5);
				mmlSimpleDrawText( fc, &screen4, "All fans of NUON", 16, &r6);

				//Erase the screen
				//m2dFillColr( &gc, &screen4, NULL, black );

				//_TimeToSleep(40);//control speed of snake or program
				
				//}
				//while(a!=300);

				do
				{	
					if(ButtonB(_Controller[1]))
					{
						PlayWAV((void *)ahhWav, -1, &Pan, 0x40000000, 0x40000000 );
						wait=1;
					}
				}while(wait==0);
		
				wait=0;

				/* show the sample pixmap */
				mmlSimpleVideoSetup(&screen2, &sysRes, eNoVideoFilter);
				
				//Erase the screen
				m2dFillColr( &gc, &screen2, NULL, black );
				
				m2dSetRect( &r5, 60, 90, 215, 140 );
				mmlSetTextProperties( fc, CollegeScriptP, 10, kBlue, black, eOpaque, 0, 0 );
				mmlSimpleDrawText( fc, &screen2, "Single Player", 13, &r5);


				m2dSetRect( &r6, 60, 110, 215, 160 );
				mmlSetTextProperties( fc, CollegeScriptP, 10, kBlue, black, eOpaque, 0, 0 );
				mmlSimpleDrawText( fc, &screen2, "Two Player", 10, &r6);
				
				m2dSetRect( &r7, 60, 130, 215, 180 );
				mmlSetTextProperties( fc, CollegeScriptP, 10, kBlue, black, eOpaque, 0, 0 );
				mmlSimpleDrawText( fc, &screen2, "Options", 7, &r7);		
			
				m2dSetRect( &r8, 60, 150, 215, 200 );
				mmlSetTextProperties( fc, CollegeScriptP, 10, kGreen, black, eOpaque, 0, 0 );
				mmlSimpleDrawText( fc, &screen2, "Credits", 7, &r8);			
			}

			if((menu_down==0)&&(menu_up==4)&&(ButtonA(_Controller[1])))
			{
				player_num=1;
				main_menu=0;
				PlayWAV((void *)GoWav, -1, &Pan, 0x40000000, 0x40000000 );
			}
			if((menu_down==1)&&(menu_up==3)&&(ButtonA(_Controller[1])))
			{
				player_num=2;
				main_menu=0;
				PlayWAV((void *)GoWav, -1, &Pan, 0x40000000, 0x40000000 );
			}
		}
	
		
		// show the game framebuffer
		mmlSimpleVideoSetup(&screen, &sysRes, eNoVideoFilter);


		while(main_menu==0)
		{
			
			if(player_num==2)
			{
				if(win==1)
				{
				
					if((player[0].points!=0)||(player[1].points!=0))
					{
						if(player[0].points>player[1].points)
						{
							m2dSetRect( &r4, 11, 60, 107, 80 );
							mmlSetTextProperties( fc, CollegeScriptP, 8, kGreen, black, eOpaque, 0, 0 );
							mmlSimpleDrawText( fc, &screen, "Player 1 Wins!", 14, &r4);
						}
						else
						{
							m2dSetRect( &r4, 11, 60, 107, 80 );
							mmlSetTextProperties( fc, CollegeScriptP, 8, kGreen, black, eOpaque, 0, 0 );
							mmlSimpleDrawText( fc, &screen, "Player 2 Wins!", 14, &r4);
						}
					}
					
					if((player[0].points==0)&&(player[1].points==0))
					{
						m2dSetRect( &r4, 45, 60, 107, 80 );
						mmlSetTextProperties( fc, CollegeScriptP, 8, kGreen, black, eOpaque, 0, 0 );
						mmlSimpleDrawText( fc, &screen, "Draw!", 5, &r4);
					}
					
					_TimeToSleep(2500);//control speed of snake or program
				}	
			}
				
			win=0;
			
			//hiscore=player[0].points;
			player[0].points=0;
			player[1].points=0;	

			/* Set all the pixels in the display pixmap to black */
			m2dFillColr( &gc, &screen, NULL, black );

			/* Draw the score player1*/
			sprintf(buffer, "%d", player[0].points);//buffer new score
			m2dSetRect( &r2, 10, 5, 55, 15 );
			m2dSetRect( &r3, 10, 13, 55, 18 );
			mmlSetTextProperties( fc, CollegeScriptP, 8, kGreen, black, eOpaque, 0, 0 );
			mmlSimpleDrawText( fc, &screen, buffer, strlen(buffer), &r3);
			mmlSimpleDrawText( fc, &screen, "P1", 2, &r2);

			if(player_num==1)
				{
					sprintf(buffer, "%d", hiscore);//buffer new score
					//draw Hi-score for player 1
					m2dSetRect( &r3, 50, 5, 110, 15 );
					m2dSetRect( &r4, 50, 13, 90, 18 );
					mmlSetTextProperties( fc, CollegeScriptP, 8, kGreen, black, eOpaque, 0, 0 );
					mmlSimpleDrawText( fc, &screen, buffer, strlen(buffer), &r4);
					//mmlSetTextProperties( fc, CollegeScriptP, 8, kGreen, black, eOpaque, 0, 0 );
					mmlSimpleDrawText( fc, &screen, "Hi-Score", 8, &r3);			
				}

			/* Draw the score player2*/
			if(player_num==2)
			{
				sprintf(buffer, "%d", player[1].points);//buffer new score
				//draw new score
				m2dSetRect( &r3, 80, 5, 110, 15 );
				m2dSetRect( &r2, 80, 13, 110, 18 );
				mmlSetTextProperties( fc, CollegeScriptP, 8, kGreen, black, eOpaque, 0, 0 );
				mmlSimpleDrawText( fc, &screen, buffer, strlen(buffer), &r2);
				mmlSimpleDrawText( fc, &screen, "P2", 2, &r3);
					
				sprintf(buffer, "%d", hiscore_2p);//buffer new score
				//draw Hi-score 
				m2dSetRect( &r2, 45, 5, 70, 15 );
				m2dSetRect( &r3, 45, 13, 80, 18 );
				mmlSetTextProperties( fc, CollegeScriptP, 8, kGreen, black, eOpaque, 0, 0 );
				mmlSimpleDrawText( fc, &screen, buffer, strlen(buffer), &r3);
				mmlSimpleDrawText( fc, &screen, "Hi", 2, &r2);
			}

			//draw playfield box
			m2dInitBox( &gc, &screen, &b1, 105, 95, 1);
			m2dDrawBox( &gc, &screen, &b1, 100, 90, 1, 10, 20, kBlue );
			
			interval=1;
			
			//Set snake to begin in middle of screen
			player[0].x_pos=60;
			player[0].y_pos=60;

			player[1].x_pos=80;
			player[1].y_pos=80;

			right=0;
			left=0;
			up=0;
			down=0;

			right_p2=0;
			left_p2=0;
			up_p2=0;
			down_p2=0;

			
			while(interval==1)
			{  
				
				//player 1 control
				if ((IRKey6(_Controller[0]))||((ButtonCRight(_Controller[1]))&&(interval==1)&&(left!=1)&&(!ButtonCDown(_Controller[1]))&&(!ButtonCUp(_Controller[1]))))
				{
					right=1;
					left=0;
					up=0;
					down=0;
					//_TimeToSleep(45);//control speed of snake or program
				}
				if ((IRKey4(_Controller[0]))||((ButtonCLeft(_Controller[1]))&&(interval==1)&&(right!=1)&&(!ButtonCDown(_Controller[1]))&&(!ButtonCUp(_Controller[1]))))
				{	
					right=0;
					left=1;
					up=0;
					down=0;
					//_TimeToSleep(45);//control speed of snake or program
				}
				if ((IRKey8(_Controller[0]))||((ButtonCDown(_Controller[1]))&&(interval==1)&&(up!=1)&&(!ButtonCRight(_Controller[1]))&&(!ButtonCLeft(_Controller[1]))))
				{	
					right=0;
					left=0;
					up=0;
					down=1;
					//_TimeToSleep(45);//control speed of snake or program
				}
				if ((IRKey2(_Controller[0]))||((ButtonCUp(_Controller[1]))&&(interval==1)&&(down!=1)&&(!ButtonCRight(_Controller[1]))&&(!ButtonCLeft(_Controller[1]))))
				{	
					right=0;
					left=0;
					up=1;
					down=0;
					//_TimeToSleep(45);//control speed of snake or program
				}

				if(freeze_p1_timer==0)
				{
					if(right==1)
					{
						player[0].x_pos++;
					}
					if(left==1)
					{
						player[0].x_pos--;
					}
					if(up==1)
					{
						player[0].y_pos--;
					}
					if(down==1)
					{
						player[0].y_pos++;
					}
				}
		
				//player2 control
				if ((ButtonCRight(_Controller[5]))&&(interval==1)&&(left_p2!=1)&&(!ButtonCDown(_Controller[5]))&&(!ButtonCUp(_Controller[5])))
				{
					right_p2=1;
					left_p2=0;
					up_p2=0;
					down_p2=0;
					//_TimeToSleep(45);//control speed of snake or program
				}
				if ((ButtonCLeft(_Controller[5]))&&(interval==1)&&(right_p2!=1)&&(!ButtonCDown(_Controller[5]))&&(!ButtonCUp(_Controller[5])))
				{	
					right_p2=0;
					left_p2=1;
					up_p2=0;
					down_p2=0;
					//_TimeToSleep(45);//control speed of snake or program
				}
				if ((ButtonCDown(_Controller[5]))&&(interval==1)&&(up_p2!=1)&&(!ButtonCRight(_Controller[5]))&&(!ButtonCLeft(_Controller[5])))
				{	
					right_p2=0;
					left_p2=0;
					up_p2=0;
					down_p2=1;
					//_TimeToSleep(45);//control speed of snake or program
				}
				if ((ButtonCUp(_Controller[5]))&&(interval==1)&&(down_p2!=1)&&(!ButtonCRight(_Controller[5]))&&(!ButtonCLeft(_Controller[5])))
				{	
					right_p2=0;
					left_p2=0;
					up_p2=1;
					down_p2=0;
					//_TimeToSleep(45);//control speed of snake or program
				}

				if(freeze_p2_timer==0)
				{
					if(right_p2==1)
					{
						player[1].x_pos++;
					}
					if(left_p2==1)
					{
						player[1].x_pos--;
					}
					if(up_p2==1)
					{
						player[1].y_pos--;
					}
					if(down_p2==1)
					{
						player[1].y_pos++;
					}
				}
				
				//determine if either snake has been started
				if(freeze_p1_timer==0)
				{
					if((right==1)||(left==1)||(up==1)||(down==1))
					{
						snake(0);
					}
				}
					
				if((player_num==2)&&(freeze_p2_timer==0))
				{
					if((right_p2==1)||(left_p2==1)||(up_p2==1)||(down_p2==1))
					{
						snake(1);
					}
				}
				
				_TimeToSleep(speed);//control speed of snake or program
					
				if(freeze_p1_timer>0)
				{
					freeze_p1_timer--;
				}
				if(freeze_p2_timer>0)
				{
					freeze_p2_timer--;
				}
				//cause siezures if pellet is eaten ;)
				if(flash>0)
				{
					/* Set all the pixels in the display pixmap to white */
					m2dFillColr( &gc, &screen3, NULL, kWhite );
					
					if(flash==1)
					{
						/* Set all the pixels in the display pixmap to black */
						m2dFillColr( &gc, &screen3, NULL, black );
					}

					/* show the sample pixmap */
					mmlSimpleVideoSetup(&screen3, &sysRes, eNoVideoFilter);

					/* show the sample pixmap */
					mmlSimpleVideoSetup(&screen, &sysRes, eNoVideoFilter);
			
					flash--;
				}
				if((ButtonStart(_Controller[1]))||(ButtonStart(_Controller[5])))
				{
					
					PlayWAV((void *)PauseWav, -1, &Pan, 0x40000000, 0x40000000 );
					
					//void m2dSmallFill(mmlGC *gc, mmlDisplayPixmap *V, int x, int y, mmlColor
					//color, int xLen, int yLen )

					m2dSmallFill(&gc, &screen, 10, 5, black, 115, 15);
					
					/* Draw the score player1*/
					sprintf(buffer, "%d", player[0].points);//buffer new score
					m2dSetRect( &r2, 10, 5, 55, 15 );
					m2dSetRect( &r3, 10, 13, 55, 18 );
					mmlSetTextProperties( fc, CollegeScriptP, 8, kGreen, black, eOpaque, 0, 0 );
					mmlSimpleDrawText( fc, &screen, "Pause", 5, &r2);
					//mmlSimpleDrawText( fc, &screen, buffer, strlen(buffer), &r3);
					
					
					sprintf(buffer, "%d", hiscore);//buffer new score
					//draw Hi-score for player 1
					m2dSetRect( &r3, 55, 5, 110, 15 );
					m2dSetRect( &r4, 55, 13, 90, 18 );
					mmlSetTextProperties( fc, CollegeScriptP, 8, kGreen, black, eOpaque, 0, 0 );
					mmlSimpleDrawText( fc, &screen, "A+B to", 6, &r3);
					//mmlSimpleDrawText( fc, &screen, buffer, strlen(buffer), &r4);
					mmlSimpleDrawText( fc, &screen, "Quit", 4, &r4);								
					
					do
					{	
						if((ButtonA(_Controller[1]))&&(ButtonB(_Controller[1])))
						{
							
							PlayWAV((void *)ahhWav, -1, &Pan, 0x40000000, 0x40000000 );
							
							main_menu=1;
							interval=0;
							
							a=0;
							pellet_present=0;
							pellet_present_2=0;
							pellet_freeze_present=0;
							
							speed=100;
							player[0].snakeHead=-1;
							player[0].snakeMax=30;

							player[1].snakeHead=-1;
							player[1].snakeMax=30;

							wait=1;
						}
						_TimeToSleep(165);//control speed of snake or program
						
						if(ButtonStart(_Controller[1]))
						{
							
							PlayWAV((void *)PauseWav, -1, &Pan, 0x40000000, 0x40000000 );
							
							m2dSmallFill(&gc, &screen, 10, 5, black, 115, 15);
							
							/* Draw the score player1*/
							sprintf(buffer, "%d", player[0].points);//buffer new score
							m2dSetRect( &r2, 10, 5, 55, 15 );
							m2dSetRect( &r3, 10, 13, 55, 18 );
							mmlSetTextProperties( fc, CollegeScriptP, 8, kGreen, black, eOpaque, 0, 0 );
							mmlSimpleDrawText( fc, &screen, buffer, strlen(buffer), &r3);
							mmlSimpleDrawText( fc, &screen, "P1", 2, &r2);

							if(player_num==1)
								{
									sprintf(buffer, "%d", hiscore);//buffer new score
									//draw Hi-score for player 1
									m2dSetRect( &r3, 50, 5, 110, 15 );
									m2dSetRect( &r4, 50, 13, 90, 18 );
									mmlSetTextProperties( fc, CollegeScriptP, 8, kGreen, black, eOpaque, 0, 0 );
									mmlSimpleDrawText( fc, &screen, buffer, strlen(buffer), &r4);
									//mmlSetTextProperties( fc, CollegeScriptP, 8, kGreen, black, eOpaque, 0, 0 );
									mmlSimpleDrawText( fc, &screen, "Hi-Score", 8, &r3);			
								}

							/* Draw the score player2*/
							if(player_num==2)
							{
								sprintf(buffer, "%d", player[1].points);//buffer new score
								//draw new score
								m2dSetRect( &r3, 80, 5, 110, 15 );
								m2dSetRect( &r2, 80, 13, 110, 18 );
								mmlSetTextProperties( fc, CollegeScriptP, 8, kGreen, black, eOpaque, 0, 0 );
								mmlSimpleDrawText( fc, &screen, buffer, strlen(buffer), &r2);
								mmlSimpleDrawText( fc, &screen, "P2", 2, &r3);
									
								sprintf(buffer, "%d", hiscore_2p);//buffer new score
								//draw Hi-score 
								m2dSetRect( &r2, 45, 5, 70, 15 );
								m2dSetRect( &r3, 45, 13, 80, 18 );
								mmlSetTextProperties( fc, CollegeScriptP, 8, kGreen, black, eOpaque, 0, 0 );
								mmlSimpleDrawText( fc, &screen, buffer, strlen(buffer), &r3);
								mmlSimpleDrawText( fc, &screen, "Hi", 2, &r2);
							}
							
							wait=1;
						}
					}while(wait==0);
				}
				wait=0;
			}
		}
	}
/* Release allocated memory */
mmlReleasePixmaps( (mmlPixmap*)&screen, &sysRes, 1 );
mmlReleasePixmaps( (mmlPixmap*)&source, &sysRes, 1 );
mmlReleasePixmaps( (mmlPixmap*)&clutSource, &sysRes, 1 );

return 0;
}

/*
 * Plot a single pixel in a display frame buffer
 */
void PlotPixel( mmlGC* gcP, mmlDisplayPixmap* screenP, int x, int y, mmlColor color )
{
	m2dRect r;
	r.leftTop.x = x;
	r.leftTop.y = y;
	r.rightBot.x = x;
	r.rightBot.y = y;
	m2dFillColr( gcP, screenP, &r, color );
}
void snake(int player_index)
{	

	if (player[player_index].snakeHead < (player[player_index].snakeMax-1))
	{
			player[player_index].snakeHead++;
	}
	else
	{
		PlotPixel( &gc, &screen, player[player_index].trail_x[0], player[player_index].trail_y[0], black);
		i=1;
		while(i<player[player_index].snakeMax)
		{
			player[player_index].trail_x[i-1]=player[player_index].trail_x[i];
			player[player_index].trail_y[i-1]=player[player_index].trail_y[i];
			i++;
		}
	}


	player[player_index].trail_x[player[player_index].snakeHead]=player[player_index].x_pos;//copy head into trail array
	player[player_index].trail_y[player[player_index].snakeHead]=player[player_index].y_pos;
		
	
	PlotPixel( &gc, &screen, player[player_index].x_pos, player[player_index].y_pos, player[player_index].snake_color );// plot head of snake
	
	if((pellet_present==0)&&(interval!=0))
	{	
		pellet();// if there are no pellets onscreen put one down
		pellet_present=1;
	}
	
	for(a=0; (a<player[player_index].snakeHead); a++)//search the trail array to determine collision of head with tail & with wall
	{
		if(((player[player_index].trail_x[a]==player[player_index].x_pos)&&(player[player_index].trail_y[a]==player[player_index].y_pos))||(player[player_index].x_pos<11)||(player[player_index].x_pos>108)||(player[player_index].y_pos<21)||(player[player_index].y_pos>108))
		{
			PlayWAV((void *)ahhWav, -1, &Pan, 0x40000000, 0x40000000 );
			interval=0;	
			a=0;
			pellet_present=0;
			pellet_present_2=0;
			pellet_freeze_present=0;

			for(i=0;i<500;i++)
			{
				player[0].trail_x[i]=0;
				player[1].trail_x[i]=0;
			}
			
			if(player[player_index].points>=hiscore)
			{
				hiscore=player[player_index].points;
			}

			if(player[0].points>=hiscore_2p)
			{
				hiscore_2p=player[0].points;
			}
			
			if(player[1].points>=hiscore_2p)
			{
				hiscore_2p=player[1].points;
			}

			speed=100;
			
			player[player_index].points=0;
			
			if(player_index!=0)
			{
				player[0].points=100;
			}

			if(player_index!=1)
			{
				player[1].points=100;
			}

			if(player_num==2)
			{
				win=1;
			}
			
			player[0].snakeHead=-1;
			player[0].snakeMax=30;

			player[1].snakeHead=-1;
			player[1].snakeMax=30;
		
		}	
	}
	
	if(player_num==2)
	{
		if((player[0].snakeHead>=1)&&(player[1].snakeHead>=1))
		{
			for(a=0; (a<player[1].snakeHead); a++)//check for collision with other snake
			{
				if((player[0].x_pos==player[1].trail_x[a])&&(player[0].y_pos==player[1].trail_y[a]))
				{	
					PlayWAV((void *)ahhWav, -1, &Pan, 0x40000000, 0x40000000 );
					interval=0;	
					a=0;
					pellet_present=0;
					pellet_present_2=0;
					pellet_freeze_present=0;

					for(i=0;i<500;i++)
					{
						player[0].trail_x[i]=0;
						player[1].trail_x[i]=0;
					}
					
					
					if(player[0].points>=hiscore_2p)
					{
						hiscore_2p=player[0].points;
					}
				
					if(player[1].points>=hiscore_2p)
					{
						hiscore_2p=player[1].points;
					}

					player[0].points=0;//player1 nailed player2 so penalize
					player[1].points=100;

					win=1;

					speed=100;
					player[0].snakeHead=-1;
					player[0].snakeMax=30;

					player[1].snakeHead=-1;
					player[1].snakeMax=30;
				}	
			}
		}

		if((player[0].snakeHead>=1)&&(player[1].snakeHead>=1))
		{

			for(a=0; (a<player[0].snakeHead); a++)
			{
				if((player[1].x_pos==player[0].trail_x[a])&&(player[1].y_pos==player[0].trail_y[a]))
				{	
					PlayWAV((void *)ahhWav, -1, &Pan, 0x40000000, 0x40000000 );
					interval=0;	
					a=0;
					pellet_present=0;
					pellet_present_2=0;
					pellet_freeze_present=0;

					for(i=0;i<500;i++)
					{
						player[0].trail_x[i]=0;
						player[1].trail_x[i]=0;
					}
					
					if(player[0].points>=hiscore_2p)
					{
						hiscore_2p=player[0].points;
					}
				
					if(player[1].points>=hiscore_2p)
					{
						hiscore_2p=player[1].points;
					}
				
					player[1].points=0; //player2 nailed player1 so penalize
					player[0].points=100;

					win=1;
					
					speed=100;
					player[0].snakeHead=-1;
					player[0].snakeMax=30;

					player[1].snakeHead=-1;
					player[1].snakeMax=30;
				}	
			}
		}
	}
	
	if((pellet_x==player[player_index].x_pos)&&(pellet_y==player[player_index].y_pos))//check for collision of head with pellet
	{
			
		player[player_index].snakeMax=player[player_index].snakeMax+10;
		PlayWAV((void *)FruitEatWav, -1, &Pan, 0x40000000, 0x40000000 );
		
		player[player_index].points=player[player_index].points+100;//increase points
		
		/* Draw the new score */
		score(player_index);

		if(speed>=50)
		{
			speed=speed-3;
		}
		
		pellet_present=0;//set pellet to zero
		flash=4;
	}
	if(player_num==2)
	{
		if((pellet_x_2==player[player_index].x_pos)&&(pellet_y_2==player[player_index].y_pos))//check for collision of head with pellet
		{
			
			player[player_index].snakeMax=player[player_index].snakeMax+10;
			PlayWAV((void *)FruitEatWav, -1, &Pan, 0x40000000, 0x40000000 );
		
			player[player_index].points=player[player_index].points+100;//increase points
		
			/* Draw the new score */
			score(player_index);
		
			flash=4;

			if(speed>=50)
			{
				speed=speed-3;
			}
		
			pellet_present_2=0;//set pellet to zero
		}
		
		//check collision with freeze pellet
		if((pellet_freeze_x==player[0].x_pos)&&(pellet_freeze_y==player[0].y_pos))//check for collision of head with pellet
		{
	
			PlayWAV((void *)FruitEatWav, -1, &Pan, 0x40000000, 0x40000000 );
		
			freeze_p2_timer=60;
			pellet_freeze_present=0;
				
		}
			
		//check collision with freeze pellet
		if((pellet_freeze_x==player[1].x_pos)&&(pellet_freeze_y==player[1].y_pos))//check for collision of head with pellet
		{
			
			PlayWAV((void *)FruitEatWav, -1, &Pan, 0x40000000, 0x40000000 );
		
			freeze_p1_timer=60;
			pellet_freeze_present=0;		
		
		}

	}
	
}

void pellet()
{
	//randomize x and y between 20-100, *redo if x and y equal snake*
	if(pellet_present==0)
	{
		
		pellet_x=rand()%98+11;
		pellet_y=rand()%88+21;
		
		for(a=0; (a<player[0].snakeHead); a++)
		{
			if((player[0].trail_x[a]==pellet_x)&&(player[0].trail_y[a]==pellet_y))
			{
				pellet_x=rand()%98+11;
				pellet_y=rand()%88+21;
				a=0;
			}
		}
		
		PlotPixel( &gc, &screen, pellet_x, pellet_y, kWhite);
	}
	
	if((player_num==2)&&(pellet_present_2==0))
	{
		pellet_x_2=rand()%98+11;
		pellet_y_2=rand()%88+21;
		
		for(a=0; (a<player[0].snakeHead); a++)
		{
			if((player[0].trail_x[a]==pellet_x)&&(player[0].trail_y[a]==pellet_y))
			{
				pellet_x=rand()%98+11;
				pellet_y=rand()%88+21;
				a=0;
			}
		}
		
		for(a=0; (a<player[1].snakeHead); a++)
		{
			if((player[1].trail_x[a]==pellet_x)&&(player[1].trail_y[a]==pellet_y))
			{
				pellet_x=rand()%98+11;
				pellet_y=rand()%88+21;
				a=0;
			}
		}
		
		PlotPixel( &gc, &screen, pellet_x_2, pellet_y_2, kWhite);
		pellet_present_2=1;

	}		
		
	if((player_num==2)&&(pellet_freeze_present==0))
	{
		if((player[0].points/300==1)||(player[1].points/300==1))
		{	
				
			pellet_freeze_x=rand()%98+11;
			pellet_freeze_y=rand()%88+21;
		
			for(a=0; (a<player[0].snakeHead); a++)
			{
				if((player[0].trail_x[a]==pellet_freeze_x)&&(player[0].trail_y[a]==pellet_freeze_y))
				{
					pellet_freeze_x=rand()%98+11;
					pellet_freeze_y=rand()%88+21;
					a=0;
				}	
			}
		
			for(a=0; (a<player[1].snakeHead); a++)
			{
				if((player[1].trail_x[a]==pellet_freeze_x)&&(player[1].trail_y[a]==pellet_freeze_y))
				{
					pellet_freeze_x=rand()%98+11;
					pellet_freeze_y=rand()%88+21;
					a=0;
				}
			}
			
			PlotPixel( &gc, &screen, pellet_freeze_x, pellet_freeze_y, kBlue);
			pellet_freeze_present=1;
		
		}
	}
}

void score(int player_index)
{
		if(player[player_index].points==player[0].points)
		{
		sprintf(buffer, "%d", player[player_index].points);//buffer new score
		//draw new score
		m2dSetRect( &r2, 10, 5, 55, 15 );
		m2dSetRect( &r3, 10, 13, 55, 18 );
		mmlSetTextProperties( fc, CollegeScriptP, 8, kGreen, black, eOpaque, 0, 0 );
		mmlSimpleDrawText( fc, &screen, buffer, strlen(buffer), &r3);
		mmlSimpleDrawText( fc, &screen, "P1", 2, &r2);

		if(player_num==1)
			{
				sprintf(buffer, "%d", hiscore);//buffer new score
				//draw Hi-score for player 1
				m2dSetRect( &r3, 50, 5, 110, 15 );
				m2dSetRect( &r4, 50, 13, 90, 18 );
				mmlSetTextProperties( fc, CollegeScriptP, 8, kGreen, black, eOpaque, 0, 0 );
				mmlSimpleDrawText( fc, &screen, buffer, strlen(buffer), &r4);
				mmlSimpleDrawText( fc, &screen, "Hi-Score", 8, &r3);			
			}
		}
		
		if(player_num==2)
		{
			if(player[player_index].points==player[1].points)
			{
				sprintf(buffer, "%d", player[player_index].points);//buffer new score
				//draw new score
				m2dSetRect( &r3, 80, 5, 110, 15 );
				m2dSetRect( &r2, 80, 13, 110, 18 );
				mmlSetTextProperties( fc, CollegeScriptP, 8, kGreen, black, eOpaque, 0, 0 );
				mmlSimpleDrawText( fc, &screen, buffer, strlen(buffer), &r2);
				mmlSimpleDrawText( fc, &screen, "P2", 2, &r3);
				
			}
				sprintf(buffer, "%d", hiscore_2p);//buffer new score
				//draw Hi-score 
				m2dSetRect( &r2, 45, 5, 70, 15 );
				m2dSetRect( &r3, 45, 13, 80, 18 );
				mmlSetTextProperties( fc, CollegeScriptP, 8, kGreen, black, eOpaque, 0, 0 );
				mmlSimpleDrawText( fc, &screen, buffer, strlen(buffer), &r3);
				mmlSimpleDrawText( fc, &screen, "Hi", 2, &r2);
		}
}

